package ru.langrafhomyak.db.jdbc_resources_manager;

import org.jetbrains.annotations.NotNull;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.Date;
import java.sql.NClob;
import java.sql.ParameterMetaData;
import java.sql.PreparedStatement;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.RowId;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.SQLXML;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;

/* package */ abstract class _PreparedStatementWrapper_Delegates extends _PreparedStatementWrapper_Logic {

	protected _PreparedStatementWrapper_Delegates(@NotNull PreparedStatement orig) {
		super(orig);
	}

	@Override
	public void cancel() throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.cancel();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int executeUpdate() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.executeUpdate();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNull(int parameterIndex, int sqlType) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNull(parameterIndex, sqlType);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBoolean(int parameterIndex, boolean x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBoolean(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setByte(int parameterIndex, byte x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setByte(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setShort(int parameterIndex, short x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setShort(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setInt(int parameterIndex, int x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setInt(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setLong(int parameterIndex, long x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setLong(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setFloat(int parameterIndex, float x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setFloat(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setDouble(int parameterIndex, double x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setDouble(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBigDecimal(int parameterIndex, BigDecimal x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBigDecimal(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setString(int parameterIndex, String x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setString(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBytes(int parameterIndex, byte[] x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBytes(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setDate(int parameterIndex, Date x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setDate(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setTime(int parameterIndex, Time x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setTime(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setTimestamp(int parameterIndex, Timestamp x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setTimestamp(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setAsciiStream(int parameterIndex, InputStream x, int length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setAsciiStream(parameterIndex, x, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	@SuppressWarnings({"deprecation"})
	public void setUnicodeStream(int parameterIndex, InputStream x, int length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setUnicodeStream(parameterIndex, x, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBinaryStream(int parameterIndex, InputStream x, int length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBinaryStream(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void clearParameters() throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.clearParameters();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setObject(int parameterIndex, Object x, int targetSqlType) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setObject(parameterIndex, x, targetSqlType);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setObject(int parameterIndex, Object x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setObject(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public boolean execute() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.execute();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void addBatch() throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.addBatch();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setCharacterStream(int parameterIndex, Reader reader, int length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setCharacterStream(parameterIndex, reader, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setRef(int parameterIndex, Ref x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setRef(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBlob(int parameterIndex, Blob x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBlob(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setClob(int parameterIndex, Clob x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setClob(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setArray(int parameterIndex, Array x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setArray(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public ResultSetMetaData getMetaData() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getMetaData();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setDate(int parameterIndex, Date x, Calendar cal) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setDate(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setTime(int parameterIndex, Time x, Calendar cal) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setTime(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setTimestamp(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNull(int parameterIndex, int sqlType, String typeName) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNull(parameterIndex, sqlType, typeName);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setURL(int parameterIndex, URL x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setURL(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public ParameterMetaData getParameterMetaData() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getParameterMetaData();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setRowId(int parameterIndex, RowId x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setRowId(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNString(int parameterIndex, String value) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNString(parameterIndex, value);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNCharacterStream(int parameterIndex, Reader value, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNCharacterStream(parameterIndex, value, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNClob(int parameterIndex, NClob value) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNClob(parameterIndex, value);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setClob(int parameterIndex, Reader reader, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setClob(parameterIndex, reader, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBlob(int parameterIndex, InputStream inputStream, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBlob(parameterIndex, inputStream, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNClob(int parameterIndex, Reader reader, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNClob(parameterIndex, reader, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setSQLXML(int parameterIndex, SQLXML xmlObject) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setSQLXML(parameterIndex, xmlObject);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setObject(parameterIndex, x, targetSqlType, scaleOrLength);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setAsciiStream(int parameterIndex, InputStream x, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setAsciiStream(parameterIndex, x, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBinaryStream(int parameterIndex, InputStream x, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBinaryStream(parameterIndex, x, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setCharacterStream(int parameterIndex, Reader reader, long length) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setCharacterStream(parameterIndex, reader, length);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setAsciiStream(int parameterIndex, InputStream x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setAsciiStream(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBinaryStream(int parameterIndex, InputStream x) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBinaryStream(parameterIndex, x);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setCharacterStream(int parameterIndex, Reader reader) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setCharacterStream(parameterIndex, reader);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNCharacterStream(int parameterIndex, Reader value) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNCharacterStream(parameterIndex, value);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setClob(int parameterIndex, Reader reader) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setClob(parameterIndex, reader);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setBlob(int parameterIndex, InputStream inputStream) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setBlob(parameterIndex, inputStream);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setNClob(int parameterIndex, Reader reader) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setNClob(parameterIndex, reader);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public ResultSet executeQuery(String sql) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeQuery(String) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int executeUpdate(String sql) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getMaxFieldSize() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getMaxFieldSize();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setMaxFieldSize(int max) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setMaxFieldSize(max);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getMaxRows() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getMaxRows();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setMaxRows(int max) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setMaxRows(max);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setEscapeProcessing(boolean enable) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setEscapeProcessing(enable);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getQueryTimeout() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getQueryTimeout();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setQueryTimeout(int seconds) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setQueryTimeout(seconds);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public SQLWarning getWarnings() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getWarnings();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void clearWarnings() throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.clearWarnings();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setCursorName(String name) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setCursorName(name);
		} finally {
			this._state.exitMethod();
		}
	}


	@Override
	public boolean execute(String sql) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("execute(String) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}


	@Override
	public int getUpdateCount() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getUpdateCount();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public boolean getMoreResults() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getMoreResults();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setFetchDirection(int direction) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setFetchDirection(direction);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getFetchDirection() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getFetchDirection();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void setFetchSize(int rows) throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.setFetchSize(rows);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getFetchSize() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getFetchSize();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getResultSetConcurrency() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getResultSetConcurrency();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getResultSetType() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getResultSetType();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void addBatch(String sql) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("addBatch(String) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public void clearBatch() throws SQLException {
		this._state.enterMethod();
		try {
			this._orig.clearBatch();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int[] executeBatch() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.executeBatch();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public Connection getConnection() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getConnection();
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public boolean getMoreResults(int current) throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getMoreResults(current);
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int executeUpdate(String sql, int autoGeneratedKeys) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String, int) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int executeUpdate(String sql, int[] columnIndexes) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String, int[]) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int executeUpdate(String sql, String[] columnIndexes) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String, String[]) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public boolean execute(String sql, int autoGeneratedKeys) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String, int) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public boolean execute(String sql, int[] columnIndexes) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String, int[]) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public boolean execute(String sql, String[] columnIndexes) throws SQLException {
		this._state.enterMethod();
		try {
			throw new SQLException("executeUpdate(String, String[]) not allowed on PreparedStatement");
		} finally {
			this._state.exitMethod();
		}
	}

	@Override
	public int getResultSetHoldability() throws SQLException {
		this._state.enterMethod();
		try {
			return this._orig.getResultSetHoldability();
		} finally {
			this._state.exitMethod();
		}
	}
}
